FLTK 1.3.2

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions
Fl_Tabs Class Reference

The Fl_Tabs widget is the "file card tabs" interface that allows you to put lots and lots of buttons and switches in a panel, as popularized by many toolkits. More...

`#include <Fl_Tabs.H>`

Inheritance diagram for Fl_Tabs:

List of all members.

## Public Member Functions
void | client_area (int &rx, int &ry, int &rw, int &rh, int tabh=0)
| Returns the position and size available to be used by its children.
| Fl_Tabs (int, int, int, int, const char *=0)
| Creates a new Fl_Tabs widget using the given position, size, and label string.
int | handle (int)
| Handles the specified event.
Fl_Widget * | push () const
int | push (Fl_Widget *)
Fl_Widget * | value ()
| Gets the currently visible widget/tab.
int | value (Fl_Widget *)
| Sets the widget to become the current visible widget/tab.
Fl_Widget * | which (int event_x, int event_y)
## Protected Member Functions
void | draw ()
| Draws the widget.
void | redraw_tabs ()

## Detailed Description

The Fl_Tabs widget is the "file card tabs" interface that allows you to put lots and lots of buttons and switches in a panel, as popularized by many toolkits.

Clicking the tab makes a child visible() by calling show() on it, and all other children are made invisible by calling hide() on them. Usually the children are Fl_Group widgets containing several widgets themselves.

Each child makes a card, and its label() is printed on the card tab, including the label font and style. The selection color of that child is used to color the tab, while the color of the child determines the background color of the pane.

The size of the tabs is controlled by the bounding box of the children (there should be some space between the children and the edge of the Fl_Tabs), and the tabs may be placed "inverted" on the bottom - this is determined by which gap is larger. It is easiest to lay this out in fluid, using the fluid browser to select each child group and resize them until the tabs look the way you want them to.

## Constructor & Destructor Documentation

Fl_Tabs::Fl_Tabs | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | const char * | l = `0`
| ) |  |

Creates a new Fl_Tabs widget using the given position, size, and label string.

The default boxtype is FL_THIN_UP_BOX.

Use add(Fl_Widget*) to add each child, which are usually Fl_Group widgets. The children should be sized to stay away from the top or bottom edge of the Fl_Tabs widget, which is where the tabs will be drawn.

All children of Fl_Tabs should have the same size and exactly fit on top of each other. They should only leave space above or below where that tabs will go, but not on the sides. If the first child of Fl_Tabs is set to "resizable()", the riders will not resize when the tabs are resized.

The destructor also deletes all the children. This allows a whole tree to be deleted at once, without having to keep a pointer to all the children in the user code. A kludge has been done so the Fl_Tabs and all of its children can be automatic (local) variables, but you must declare the Fl_Tabs widget first so that it is destroyed last.

## Member Function Documentation

void Fl_Tabs::client_area | ( | int & | rx,
|  | int & | ry,
|  | int & | rw,
|  | int & | rh,
|  | int | tabh = `0`
| ) |  |

Returns the position and size available to be used by its children.

If there isn't any child yet the `tabh` parameter will be used to calculate the return values. This assumes that the children's labelsize is the same as the Fl_Tabs' labelsize and adds a small border.

If there are already children, the values of child(0) are returned, and `tabh` is ignored.

Note:
  Children should always use the same positions and sizes.

`tabh` can be one of

- 0: calculate label size, tabs on top
- -1: calculate label size, tabs on bottom
- > 0: use given `tabh` value, tabs on top (height = tabh)
- < -1: use given `tabh` value, tabs on bottom (height = -tabh)

Parameters:

  [in] | tabh | position and optional height of tabs (see above)
  [out] | rx,ry,rw,rh | (x,y,w,h) of client area for children

Since:
  FLTK 1.3.0

void Fl_Tabs::draw | ( |  | ) | `[protected, virtual]`

Draws the widget.

Never call this function directly. FLTK will schedule redrawing whenever needed. If your widget must be redrawn as soon as possible, call redraw() instead.

Override this function to draw your own widgets.

If you ever need to call another widget's draw method from within your own draw() method, e.g. for an embedded scrollbar, you can do it (because draw() is virtual) like this:

            Fl_Widget *s = &scroll;         // scroll is an embedded Fl_Scrollbar
            s->draw();                      // calls Fl_Scrollbar::draw()

Reimplemented from Fl_Group.

int Fl_Tabs::handle | ( | int | event | ) | `[virtual]`

Handles the specified event.

You normally don't call this method directly, but instead let FLTK do it when the user interacts with the widget.

When implemented in a widget, this function must return 0 if the widget does not use the event or 1 otherwise.

Most of the time, you want to call the inherited handle() method in your overridden method so that you don't short-circuit events that you don't handle. In this last case you should return the callee retval.

Parameters:

  [in] | event | the kind of event received

Return values:

  0 | if the event was not used or understood
  1 | if the event was used and can be deleted

See also:
  Fl_Event

Reimplemented from Fl_Group.

Fl_Widget * Fl_Tabs::value | ( |  | ) |

Gets the currently visible widget/tab.

The value() is the first visible child (or the last child if none are visible) and this also hides any other children. This allows the tabs to be deleted, moved to other groups, and show()/hide() called without it screwing up.

int Fl_Tabs::value | ( | Fl_Widget * | newvalue | ) |

Sets the widget to become the current visible widget/tab.

Setting the value hides all other children, and makes this one visible, if it is really a child.

The documentation for this class was generated from the following files:

- Fl_Tabs.H
- Fl_Tabs.cxx